﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace DependencyInjectionExample.DiConstructor
{
    internal class DiConstructorCommand : ICommand
    {
        private Action<object> _action;

        public DiConstructorCommand(Action<object> action)
        {
            _action = action;
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            if (parameter != null)
            {
                _action(parameter);
            }
            else
            {
                _action("I have no idea why I have to write something here");
            }
        }

        public event EventHandler CanExecuteChanged;
    }
}