﻿using System.IO;
using System.Windows;

namespace DependencyInjectionExample.WithoutDi
{
    class ActOnMessage
    {
        public void ShowMessage(string message)
        {
            MessageBox.Show(message);
        }

        public void WriteMessageToFile(object obj)
        {
            string _exePath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location);
            string _file = _exePath + "\\helloWorld.txt";
            try
            {
                TextWriter tw = new StreamWriter(_file);

                // write a line of text to the file
                tw.WriteLine("test");

                // close the stream
                tw.Close();
            }
            catch
            {
                MessageBox.Show("Unable to write file to: " + _file);
            }
            finally
            {
                MessageBox.Show("Mesage was successfully writen to: " + _file);
            }
        }
    }

    class DoTheMessageWithoutDi
    {
        private ActOnMessage _actOnMessage = null;

        public void ShowMesage(object o)
        {
            if (_actOnMessage == null)
            {
                _actOnMessage = new ActOnMessage();
            }
            _actOnMessage.ShowMessage("Hello world!");
        }

        public void WriteMessage(object o)
        {
            if (_actOnMessage == null)
            {
                _actOnMessage = new ActOnMessage();
            }
            _actOnMessage.WriteMessageToFile("Hello world!");
        }
    }
}