﻿using System;
using System.Windows.Input;

namespace DependencyInjectionExample.WithoutDi
{
    class WithoutDiCommand: ICommand
    {
        private Action<object> _action;

        public WithoutDiCommand(Action<object> action)
        {
            _action = action;
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public void Execute(object parameter)
        {
            if (parameter != null)
            {
                _action(parameter);
            }
            else
            {
                _action("I have no idea why I have to write something here");
            }
        }

        public event EventHandler CanExecuteChanged;
    }
}